#include <iostream>
#include <string>
#include "listas_lineares.h"
using namespace std;

bool cheia(LISTA* l) {
	if(tamanho(l) == MAX) {
		return true;
	} else {
		return false;
	}
}

void inicializaListaSequencial(LISTA* l) {
      l->nroElem = 0;
}

void exibeLista(LISTA* l) {
	for (int i = 0; i < l->nroElem; i++) {
		cout << l->A[i] << " ";
	}

	cout << endl;
}

int busca_sequencial(int elem, LISTA* l) {
	for(int i = 0; i < l->nroElem; i++) {
		if (l->A[i] == elem) {
			return i + 1;
		}
	}	

	return 0;
}

int tamanho(LISTA* l) {
      return l->nroElem;
}

int primeiroElem(LISTA* l) {
	if(l->nroElem > 0) {
		return l->A[0]; 
	} else { 
		return LISTA_VAZIA;
	}
}

int ultimoElem(LISTA* l) {
	if(l->nroElem > 0) { 
		return l->A[l->nroElem-1]; 
	} else {
		return LISTA_VAZIA;
	}
}

int enesimoElem(LISTA* l, int n) {
	if(n > 0 && n <= l->nroElem) {
		return l->A[n-1];
	} else {
		return ERRO; // :(  a lista nao pode conter o elemento -1
	}
}

void destroiLista(LISTA* l) {
	l->nroElem = 0;
}

// devolve o numero de elementos da lista apos insercao
int insere_no_final(LISTA* l, int elem) {
	if(cheia(l)) {
		return ERRO;
	}

	l->A[l->nroElem] = elem;
	l->nroElem = l->nroElem + 1;
	return l->nroElem;
}

bool insere_na_posicao_i(int elem, int i, LISTA *l) {
	// posicao eh valida?
	if(i <= 0 || i > l->nroElem + 1) { 
		return false;
	}

	if(cheia(l)) {
		return false;
	}

	for(int j = l->nroElem - 1; j >= (i - 1); j-- ) {
		l->A[j+1] = l->A[j];
	}
	
	l->A[i-1]= elem;
	l->nroElem++;
	return true;
}

int main() {
	int n;
	cin >> n;
	LISTA l;
	inicializaListaSequencial(&l);

	for(int i = 0; i < n; i++) {
		int elem;
		cin >> elem;
		cout << "insere " << elem << endl;
		insere_no_final(&l, elem);
	}

	cout << "exibe lista: " << ends;
	exibeLista(&l);

	while(true) {
		int pos, elem;
		cin >> pos >> elem;
		insere_na_posicao_i(elem, pos, &l);
		exibeLista(&l);
	}

	return 0;
}